# === class: brocadevtm::user_groups_monitoring
#
# This class is a direct implementation of brocadvtm::user_groups
#
# Please refer to the documentation in that module for more information
#
class brocadevtm::user_groups_monitoring (
  $ensure                      = present,
  $basic__description          = 'Access only to config summary / monitoring pages',
  $basic__password_expire_time = 0,
  $basic__permissions          = '[{"name":"AFM","access_level":"none"},{"name":"AFM!Admin","access_level":"none"},{"name":"Access_Management","access_level":"ro"},{"name":"Access_Management!AuthenticationMethods","access_level":"none"},{"name":"Access_Management!AuthenticationMethods!Edit","access_level":"none"},{"name":"Access_Management!Groups","access_level":"none"},{"name":"Access_Management!Groups!Edit","access_level":"none"},{"name":"Access_Management!LocalUsers","access_level":"ro"},{"name":"Access_Management!LocalUsers!Edit","access_level":"full"},{"name":"Access_Management!LocalUsers!EditOtherUsers","access_level":"none"},{"name":"Access_Management!LocalUsers!PasswordPolicy","access_level":"none"},{"name":"Access_Management!Suspended_Users","access_level":"none"},{"name":"Alerting","access_level":"none"},{"name":"Alerting!Actions","access_level":"none"},{"name":"Alerting!Actions!Edit","access_level":"none"},{"name":"Alerting!Event_Types","access_level":"none"},{"name":"Alerting!Event_Types!Edit","access_level":"none"},{"name":"Analytics_Export","access_level":"none"},{"name":"Analytics_Export!Log_Files","access_level":"none"},{"name":"Analytics_Export!Log_Files!Edit","access_level":"none"},{"name":"Appliance_Console","access_level":"none"},{"name":"Aptimizer","access_level":"none"},{"name":"Aptimizer!Aptimizer_Profiles","access_level":"none"},{"name":"Aptimizer!Aptimizer_Profiles!Edit","access_level":"none"},{"name":"Aptimizer!URL_Sets","access_level":"none"},{"name":"Aptimizer!URL_Sets!Edit","access_level":"none"},{"name":"Audit_Log","access_level":"none"},{"name":"Audit_Log!Audit_Archive","access_level":"none"},{"name":"Authenticators","access_level":"none"},{"name":"Authenticators!Edit","access_level":"none"},{"name":"Backup","access_level":"none"},{"name":"Backup!Config_Difference","access_level":"none"},{"name":"Backup!Edit","access_level":"none"},{"name":"Backup!Partial","access_level":"none"},{"name":"Bandwidth","access_level":"none"},{"name":"Bandwidth!Edit","access_level":"none"},{"name":"Bandwidth!Edit!CopyClass","access_level":"none"},{"name":"Catalog","access_level":"none"},{"name":"Cloud_Credentials","access_level":"none"},{"name":"Cloud_Credentials!Edit","access_level":"none"},{"name":"Config_Summary","access_level":"full"},{"name":"Configure","access_level":"none"},{"name":"Connections","access_level":"full"},{"name":"Connections!Details","access_level":"full"},{"name":"Custom","access_level":"none"},{"name":"DNS_Server","access_level":"none"},{"name":"DNS_Server!Zonefiles","access_level":"none"},{"name":"DNS_Server!Zones","access_level":"none"},{"name":"DNS_Server!Zones!Edit","access_level":"none"},{"name":"DateTime","access_level":"none"},{"name":"Diagnose","access_level":"ro"},{"name":"Diagnose!Replicate","access_level":"none"},{"name":"Draining","access_level":"full"},{"name":"Event_Log","access_level":"full"},{"name":"Event_Log!Clear","access_level":"none"},{"name":"Event_Log!Event_Archive","access_level":"full"},{"name":"Extra_Files","access_level":"none"},{"name":"Extra_Files!Action_Programs","access_level":"none"},{"name":"Extra_Files!ExternProgMonitors","access_level":"none"},{"name":"Extra_Files!Miscellaneous_Files","access_level":"none"},{"name":"Fault_Tolerance","access_level":"none"},{"name":"Fault_Tolerance!BGP_Neighbors","access_level":"none"},{"name":"Fault_Tolerance!BGP_Neighbors!Edit","access_level":"none"},{"name":"GLB_Services","access_level":"none"},{"name":"GLB_Services!Edit","access_level":"none"},{"name":"GLB_Services!Edit!DNSSEC","access_level":"none"},{"name":"GLB_Services!Edit!DNS_Settings","access_level":"none"},{"name":"GLB_Services!Edit!Load_Balancing","access_level":"none"},{"name":"GLB_Services!Edit!Locations","access_level":"none"},{"name":"GLB_Services!Edit!Request_Logging","access_level":"none"},{"name":"GLB_Services!Edit!Rules","access_level":"none"},{"name":"Global_Settings","access_level":"none"},{"name":"Global_Settings!Restore_Defaults","access_level":"none"},{"name":"Hardware","access_level":"none"},{"name":"Help","access_level":"full"},{"name":"Java","access_level":"none"},{"name":"Java!Edit","access_level":"none"},{"name":"Kerberos","access_level":"none"},{"name":"Kerberos!Kerberos_Keytabs","access_level":"none"},{"name":"Kerberos!Kerberos_Principals","access_level":"none"},{"name":"Kerberos!Kerberos_Principals!Edit","access_level":"none"},{"name":"Kerberos!krb5confs","access_level":"none"},{"name":"License_Keys","access_level":"none"},{"name":"License_Keys!InstallNew","access_level":"none"},{"name":"License_Keys!Register","access_level":"none"},{"name":"License_Keys!Remove","access_level":"none"},{"name":"Locations","access_level":"none"},{"name":"Locations!Edit","access_level":"none"},{"name":"Log_Viewer","access_level":"full"},{"name":"Log_Viewer!View","access_level":"full"},{"name":"MainIndex","access_level":"ro"},{"name":"Map","access_level":"ro"},{"name":"Monitoring","access_level":"full"},{"name":"Monitoring!Edit","access_level":"full"},{"name":"Monitors","access_level":"none"},{"name":"Monitors!Edit","access_level":"none"},{"name":"Monitors!Edit!CopyMonitor","access_level":"none"},{"name":"Networking","access_level":"none"},{"name":"Networking!NAT","access_level":"none"},{"name":"Persistence","access_level":"none"},{"name":"Persistence!Edit","access_level":"none"},{"name":"Persistence!Edit!CopyClass","access_level":"none"},{"name":"Pools","access_level":"none"},{"name":"Pools!Edit","access_level":"none"},{"name":"Pools!Edit!Autoscaling","access_level":"none"},{"name":"Pools!Edit!Bandwidth","access_level":"none"},{"name":"Pools!Edit!DNSAutoscaling","access_level":"none"},{"name":"Pools!Edit!IP_Transparency","access_level":"none"},{"name":"Pools!Edit!Kerberos_Protocol_Transition","access_level":"none"},{"name":"Pools!Edit!Load_Balancing","access_level":"none"},{"name":"Pools!Edit!Monitors","access_level":"none"},{"name":"Pools!Edit!Persistence","access_level":"none"},{"name":"Pools!Edit!Protocol_Settings","access_level":"none"},{"name":"Pools!Edit!SSL","access_level":"none"},{"name":"Pools!Edit!Service_Discovery","access_level":"none"},{"name":"Rate","access_level":"none"},{"name":"Rate!Edit","access_level":"none"},{"name":"Reboot","access_level":"none"},{"name":"Request_Logs","access_level":"none"},{"name":"Restart","access_level":"none"},{"name":"Routing","access_level":"ro"},{"name":"Rules","access_level":"none"},{"name":"Rules!Edit","access_level":"none"},{"name":"Rules!Edit!CheckSyntax","access_level":"none"},{"name":"Rules!Edit!SaveAs","access_level":"none"},{"name":"Rules!GEdit","access_level":"none"},{"name":"Rules!GEdit!AddAction","access_level":"none"},{"name":"Rules!GEdit!AddCondition","access_level":"none"},{"name":"Rules!GEdit!Convert","access_level":"none"},{"name":"SAML","access_level":"none"},{"name":"SAML!Trusted_Identity_Providers","access_level":"none"},{"name":"SAML!Trusted_Identity_Providers!Edit","access_level":"none"},{"name":"SLM","access_level":"none"},{"name":"SLM!Edit","access_level":"none"},{"name":"SLM!Edit!CopyClass","access_level":"none"},{"name":"SNMP","access_level":"none"},{"name":"SOAP_API","access_level":"none"},{"name":"SSL","access_level":"none"},{"name":"SSL!CAs","access_level":"none"},{"name":"SSL!CAs!Edit","access_level":"none"},{"name":"SSL!CAs!Import","access_level":"none"},{"name":"SSL!Client_Certs","access_level":"none"},{"name":"SSL!Client_Certs!Edit","access_level":"none"},{"name":"SSL!Client_Certs!Edit!Chain","access_level":"none"},{"name":"SSL!Client_Certs!Edit!CopyCert","access_level":"none"},{"name":"SSL!Client_Certs!Edit!Sign","access_level":"none"},{"name":"SSL!Client_Certs!Import","access_level":"none"},{"name":"SSL!Client_Certs!New","access_level":"none"},{"name":"SSL!DNSSEC_Keys","access_level":"none"},{"name":"SSL!SSL_Certs","access_level":"none"},{"name":"SSL!SSL_Certs!Edit","access_level":"none"},{"name":"SSL!SSL_Certs!Edit!Chain","access_level":"none"},{"name":"SSL!SSL_Certs!Edit!CopyCert","access_level":"none"},{"name":"SSL!SSL_Certs!Edit!Sign","access_level":"none"},{"name":"SSL!SSL_Certs!Import","access_level":"none"},{"name":"SSL!SSL_Certs!New","access_level":"none"},{"name":"SSL!Ticket_Keys","access_level":"none"},{"name":"Security","access_level":"none"},{"name":"Service_Discovery","access_level":"none"},{"name":"Service_Discovery!Builtin_Plugins","access_level":"none"},{"name":"Service_Discovery!User_Plugins","access_level":"none"},{"name":"Service_Protection","access_level":"none"},{"name":"Service_Protection!Edit","access_level":"none"},{"name":"Service_Protection!Edit!CopyClass","access_level":"none"},{"name":"Shutdown","access_level":"none"},{"name":"Statd","access_level":"full"},{"name":"Support","access_level":"none"},{"name":"Support!TSR","access_level":"none"},{"name":"Support_Files","access_level":"none"},{"name":"Sysctl","access_level":"none"},{"name":"Traffic_IP_Groups","access_level":"none"},{"name":"Traffic_IP_Groups!Edit","access_level":"none"},{"name":"Traffic_IP_Groups!Networking","access_level":"none"},{"name":"Traffic_Managers","access_level":"none"},{"name":"Traffic_Managers!AddRemove","access_level":"none"},{"name":"Traffic_Managers!Rollback","access_level":"none"},{"name":"Traffic_Managers!Upgrade","access_level":"none"},{"name":"Virtual_Servers","access_level":"none"},{"name":"Virtual_Servers!Edit","access_level":"none"},{"name":"Virtual_Servers!Edit!Aptimizer_Settings","access_level":"none"},{"name":"Virtual_Servers!Edit!Authentication","access_level":"none"},{"name":"Virtual_Servers!Edit!Classes","access_level":"none"},{"name":"Virtual_Servers!Edit!Content_Caching","access_level":"none"},{"name":"Virtual_Servers!Edit!Content_Compression","access_level":"none"},{"name":"Virtual_Servers!Edit!DNS_Server","access_level":"none"},{"name":"Virtual_Servers!Edit!Error_Logging","access_level":"none"},{"name":"Virtual_Servers!Edit!GLB_Services","access_level":"none"},{"name":"Virtual_Servers!Edit!Kerberos_Protocol_Transition","access_level":"none"},{"name":"Virtual_Servers!Edit!Protocol_Settings","access_level":"none"},{"name":"Virtual_Servers!Edit!Request_Logging","access_level":"none"},{"name":"Virtual_Servers!Edit!Request_Tracing","access_level":"none"},{"name":"Virtual_Servers!Edit!Rules","access_level":"none"},{"name":"Virtual_Servers!Edit!Rules!EnableDisable","access_level":"none"},{"name":"Virtual_Servers!Edit!Rules!Move","access_level":"none"},{"name":"Virtual_Servers!Edit!Rules!OnceEvery","access_level":"none"},{"name":"Virtual_Servers!Edit!Rules!Remove","access_level":"none"},{"name":"Virtual_Servers!Edit!SSL_Decryption","access_level":"none"},{"name":"Web_Cache","access_level":"full"},{"name":"Web_Cache!Clear","access_level":"none"},{"name":"Wizard!AptimizeService","access_level":"none"},{"name":"Wizard!AzureKeyVault","access_level":"none"},{"name":"Wizard!Backup","access_level":"none"},{"name":"Wizard!ClusterJoin","access_level":"none"},{"name":"Wizard!DisableNode","access_level":"none"},{"name":"Wizard!DrainNode","access_level":"none"},{"name":"Wizard!EnableRule","access_level":"none"},{"name":"Wizard!FreeDiskSpace","access_level":"none"},{"name":"Wizard!NewService","access_level":"none"},{"name":"Wizard!PulseConnectSecure","access_level":"none"},{"name":"Wizard!ReactivateNode","access_level":"none"},{"name":"Wizard!RemoveNode","access_level":"none"},{"name":"Wizard!Restore","access_level":"none"},{"name":"Wizard!SSLDecryptService","access_level":"none"}]',
  $basic__timeout              = 30,
){
  include brocadevtm
  $ip              = $brocadevtm::rest_ip
  $port            = $brocadevtm::rest_port
  $user            = $brocadevtm::rest_user
  $pass            = $brocadevtm::rest_pass
  $purge           = $brocadevtm::purge
  $purge_state_dir = $brocadevtm::purge_state_dir

  info ("Configuring user_groups_monitoring ${name}")
  vtmrest { 'user_groups/Monitoring':
    ensure   => $ensure,
    before   => Class[brocadevtm::purge],
    endpoint => "https://${ip}:${port}/api/tm/6.0/config/active",
    username => $user,
    password => $pass,
    content  => template('brocadevtm/user_groups.erb'),
    type     => 'application/json',
    internal => 'user_groups_monitoring',
    failfast => $brocadevtm::failfast,
    debug    => $brocadevtm::debug,
  }

  if ( $purge ) {
    ensure_resource('file', "${purge_state_dir}/user_groups", {ensure => present})
    file_line { 'user_groups/Monitoring':
      line => 'user_groups/Monitoring',
      path => "${purge_state_dir}/user_groups",
    }
  }
}
